# Gridlock - a collection of grid-based strategy games
# Copyright (c) 2009 Brian Nenninger (brian@dozingcatsoftware.com)
# Gridlock comes with ABSOLUTELY NO WARRANTY, and is released under version 3 of the GNU GPL.

import wx
import wx.xrc
import socket
import threading
import PGChat

class Controller(object):
    def __init__(self, controller):
        import os.path
        self.game_controller = controller
        self.res = wx.xrc.XmlResource(os.path.join('xrc', 'pygrid_client.xrc'))
        self.frame = self.res.LoadDialog(None, 'mainFrame')
        self.frame.Bind(wx.EVT_CLOSE, self.hideWindow)
        
        self.host_field = wx.xrc.XRCCTRL(self.frame, 'hostField')
        self.port_field = wx.xrc.XRCCTRL(self.frame, 'portField')
        
        connect_button = wx.xrc.XRCCTRL(self.frame, 'connectButton')
        connect_button.Bind(wx.EVT_BUTTON, self.doConnect)
        connect_button.SetDefault()
        
        wx.xrc.XRCCTRL(self.frame, 'mainPanel').GetSizer().Fit(self.frame)
        
    def showWindow(self):
        self.frame.Show()
        self.frame.Raise()
        self.host_field.SetFocus()

    def hideWindow(self, event=None):
        self.frame.Hide()

    def doConnect(self, event):
        port = int(self.port_field.GetValue())
        host = self.host_field.GetValue()

        self.game_controller.network_connect(host, port)

    def network_connected(self, sock):
        pass
        